/****************************************************************************
*   serial.h -- Serial device handling routines                             *
*   Copyright (C) 1998  Peter Mack, DL3FCJ                                  *
****************************************************************************/

#include <termios.h>
#include <linux/serial.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#include "lock.h"


typedef struct _SERDATA {
	struct _SERDATA	*Next;
	struct _SERDATA	*Prev;
	char		*device;
	int		devicehandle;
	struct termios	old_termios;
} SERDATA, *PSERDATA;
	

/*
 * function prototypes
 */
int rs232_open(char *, int);
void rs232_close(int);
int rs232_read(int, void *, int);
int rs232_readflush(int);
int rs232_Flush(int);
int rs232_Status(int);
void rs232_DTR(int, char);
void rs232_RTS(int, char);
int rs232_GetCTS(int);
int rs232_GetDSR(int);
int rs232_GetDCD(int);
int rs232_GetRI(int);
PSERDATA find_device(int);
