/****************************************************************************
*   update.h -- PTC-II update handling                                      *
*   Copyright (C) 1998  Peter Mack, DL3FCJ                                  *
****************************************************************************/

#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <time.h>


#define	MAX_SECT_SIZE	512

#define ACK '\006'
#define ESC '\033'


/*
 * Flash Device Data
 */
typedef struct {
	char		*Manufacturer;  /* Manufacturer string */
	char		*Type;          /* Flash type string */
	unsigned short	usSectSize;     /* Sector size of flash */
	unsigned long	ulFlashSize;    /* Size of flash */
} FLASH, *PFLASH;


/*
 * 68k data structures
 */
typedef union {
	unsigned long	l;
	unsigned char	c[4];
} ULDATA;

typedef union {
	unsigned short	s;
	unsigned char	c[2];
} USDATA;


/*
 * PT2 date and time
 */
typedef struct _FDATE {
	unsigned int	day	: 5;
	unsigned int	month	: 4;
	unsigned int	year	: 7; /* = year - 1980 */
} FDATE;


typedef struct _FTIME {
	unsigned int	twosecs	: 5;
	unsigned int	minutes	: 6;
	unsigned int	hours	: 5;
} FTIME;


typedef struct _FDTIME {
	unsigned int	twosecs	: 5;
	unsigned int	minutes	: 6;
	unsigned int	hours	: 5;
	unsigned int	day	: 5;
	unsigned int	month	: 4;
	unsigned int	year	: 7; /* = year - 1980 */
} FDTIME;


/*
 * Function Prototypes
 */
int Update(int, char *);
int GetFlash (char, char, FLASH *);
time_t convtime(FDTIME);
